Attribute VB_Name = "HSB_Convertion"

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Benjamin Wilger

Option Explicit

Public Const HSB_HueMAX = 360
Public Const HSB_SatBrightMAX = 100 'Gute Werte fr die Sttigung und die Helligkeit
                                    'sind 100 (Prozent) oder 255 (Byte)
Private Const UNDEFINED As Integer = -1
Private Const HSB_RGBMAX = 255

Public Function RGBtoHSB(ByVal RGB_R As Integer, ByVal RGB_G As Integer, ByVal RGB_B As Integer, _
                         ByRef HSB_H As Integer, ByRef HSB_S As Integer, ByRef HSB_B As Integer)
    Dim Min As Double
    Dim Max As Double
    Dim Delta As Double
    Dim temp As Double
    
    Min = getMinValue(RGB_R, RGB_G, RGB_B)
    Max = getMaxValue(RGB_R, RGB_G, RGB_B)
    Delta = Max - Min
    
    HSB_B = Int(Max) / HSB_RGBMAX * HSB_SatBrightMAX
    
    If Delta = 0 Then
        HSB_H = UNDEFINED
        HSB_S = 0
    Else
        temp = Delta / Max
        HSB_S = temp * HSB_SatBrightMAX
        If RGB_R = Max Then
            temp = (RGB_G - RGB_B) / Delta
        ElseIf RGB_G = Max Then
            temp = 2 + (RGB_B - RGB_R) / Delta
        Else
            temp = 4 + (RGB_R - RGB_G) / Delta
        End If
        temp = temp * 60
        If temp < 0 Then
            temp = temp + 360
        End If
        HSB_H = temp
    End If
    
    If Not HSB_H = UNDEFINED Then
        HSB_H = HSB_H / 360 * HSB_HueMAX
    Else
        HSB_H = 0
    End If
End Function

Public Function HSBtoRGB(ByVal HSB_H As Integer, ByVal HSB_S As Integer, ByVal HSB_B As Integer, _
                         ByRef RGB_R As Integer, ByRef RGB_G As Integer, ByRef RGB_B As Integer)
    Dim Min As Double
    Dim Max As Double
    Dim Delta As Double
    Dim Hue As Double
    
    HSB_H = HSB_H / HSB_HueMAX * 360
    
    If HSB_H = 0 And HSB_S = 0 Then
        RGB_R = HSB_B / HSB_SatBrightMAX * HSB_RGBMAX
        RGB_G = RGB_R
        RGB_B = RGB_R
    Else
        Max = HSB_B / HSB_SatBrightMAX * HSB_RGBMAX
        Delta = (Max * HSB_S) / HSB_SatBrightMAX
        Min = Max - Delta
        
        Hue = HSB_H
        If HSB_H > 300 Or HSB_H <= 60 Then
            RGB_R = Max
            If HSB_H > 300 Then
                RGB_G = Min
                Hue = (Hue - 360) / 60
                RGB_B = (Hue * Delta - Min) * -1
            Else
                RGB_B = Min
                Hue = Hue / 60
                RGB_G = Hue * Delta + Min
            End If
        Else
            If HSB_H > 60 And HSB_H < 180 Then
                RGB_G = Max
                If HSB_H < 120 Then
                    RGB_B = Min
                    Hue = (Hue / 60 - 2) * Delta
                    RGB_R = Min - Hue
                Else
                    RGB_R = Min
                    Hue = (Hue / 60 - 2) * Delta
                    RGB_B = Min + Hue
                End If
            Else
                RGB_B = Max
                If HSB_H < 240 Then
                    RGB_R = Min
                    Hue = (Hue / 60 - 4) * Delta
                    RGB_G = Min - Hue
                Else
                    RGB_G = Min
                    Hue = (Hue / 60 - 4) * Delta
                    RGB_R = Min + Hue
                End If
            End If
        End If
    End If
End Function


