Attribute VB_Name = "HSV_Convertion"

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Benjamin Wilger

Option Explicit
'HSV, HLS, HSL, FSH ...
'Das sind nur einige der Namen dieses Farbmodells. Ich habe mich fr HSV entschieden...

Public Const HSV_MAX = 240

Private Const UNDEFINED As Integer = -1
Private Const HSV_RGBMAX = 255

Public Sub RGBtoHSV(ByVal RGB_R As Integer, ByVal RGB_G As Integer, ByVal RGB_B As Integer, _
                    ByRef HSV_H As Integer, ByRef HSV_S As Integer, ByRef HSV_V As Integer)
    
    Dim Max As Integer, Min As Integer
    Dim Minus As Long, Plus As Long
    Dim RDelta As Double, GDelta As Double, BDelta As Double

    Min = getMinValue(RGB_R, RGB_G, RGB_B)
    Max = getMaxValue(RGB_R, RGB_G, RGB_B)
    
    Minus = Max - Min
    Plus = Max + Min
    
    HSV_V = ((Plus * HSV_MAX) + HSV_RGBMAX) / (2 * HSV_RGBMAX)
    
    If Max = Min Then
        HSV_H = 0
        HSV_S = 0
    Else

        If HSV_V <= (HSV_MAX / 2) Then
            HSV_S = ((Minus * HSV_MAX) + 0.5) / Plus
        Else
            HSV_S = ((Minus * HSV_MAX) + 0.5) / (2 * HSV_RGBMAX - Plus)
        End If

        RDelta = (((Max - RGB_R) * (HSV_MAX / 6)) + 0.5) / Minus
        GDelta = (((Max - RGB_G) * (HSV_MAX / 6)) + 0.5) / Minus
        BDelta = (((Max - RGB_B) * (HSV_MAX / 6)) + 0.5) / Minus

        Select Case Max
            Case CLng(RGB_R)
                HSV_H = BDelta - GDelta
            Case CLng(RGB_G)
                HSV_H = (HSV_MAX / 3) + RDelta - BDelta
            Case CLng(RGB_B)
                HSV_H = ((2 * HSV_MAX) / 3) + GDelta - RDelta
        End Select

        Do While HSV_H < 0
            HSV_H = HSV_H + HSV_MAX
        Loop
        HSV_H = HSV_H Mod HSV_MAX
        
    End If
    
End Sub

Public Sub HSVtoRGB(ByVal HSV_H As Integer, ByVal HSV_S As Integer, ByVal HSV_V As Integer, _
                    ByRef RGB_R As Integer, ByRef RGB_G As Integer, ByRef RGB_B As Integer)

    Dim R As Long, G As Long, B As Long
    Dim H As Long, S As Long, V As Long
    Dim Magic1 As Integer, Magic2 As Integer
    
    H = HSV_H
    S = HSV_S
    V = HSV_V

    If S = 0 Then
        R = (V * HSV_RGBMAX) / HSV_MAX
        G = R
        B = R

    Else
        If V <= HSV_MAX / 2 Then
            Magic2 = (V * (HSV_MAX + S) + _
                (HSV_MAX / 2)) / HSV_MAX
        Else
            Magic2 = V + S - ((V * S) + _
                (HSV_MAX / 2)) / HSV_MAX
        End If
        Magic1 = 2 * V - Magic2
        
        R = (HuetoRGB(Magic1, Magic2, H + (HSV_MAX / 3)) _
            * HSV_RGBMAX + (HSV_MAX / 2)) / HSV_MAX
        G = (HuetoRGB(Magic1, Magic2, H) _
            * HSV_RGBMAX + (HSV_MAX / 2)) / HSV_MAX
        B = (HuetoRGB(Magic1, Magic2, H - (HSV_MAX / 3)) _
            * HSV_RGBMAX + (HSV_MAX / 2)) / HSV_MAX
    End If
    RGB_R = setRange(R, 0, 255)
    RGB_G = setRange(G, 0, 255)
    RGB_B = setRange(B, 0, 255)
    
End Sub
Private Function HuetoRGB(mag1 As Integer, mag2 As Integer, Hue As Long) As Long

    If Hue < 0 Then
        Hue = Hue + HSV_MAX
    ElseIf Hue > HSV_MAX Then
        Hue = Hue - HSV_MAX
    End If
    Select Case Hue
        Case Is < (HSV_MAX / 6)
            HuetoRGB = (mag1 + (((mag2 - mag1) * Hue + (HSV_MAX / 12)) / (HSV_MAX / 6)))
        Case Is < (HSV_MAX / 2)
            HuetoRGB = mag2
        Case Is < (HSV_MAX * 2 / 3)
            HuetoRGB = (mag1 + (((mag2 - mag1) * ((HSV_MAX * 2 / 3) - Hue) + (HSV_MAX / 12)) / (HSV_MAX / 6)))
        Case Else
            HuetoRGB = mag1
    End Select

End Function
