Attribute VB_Name = "LAB_LUV_Convertion"

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Benjamin Wilger

Option Explicit

'YUV ist Lab vom Aufbau etwas hnlich. Es heisst auch YCrCb

Private Const LAB_RGBMAX = 255

Public Const LAB_L_Max = 100

Public Const LAB_AB_Min = -128
Public Const LAB_AB_Max = 127

Public Const LAB_AB_Num = 255

Public Sub RGBtoYUV(ByVal RGB_R As Integer, ByVal RGB_G As Integer, ByVal RGB_B As Integer, _
                    ByRef YUV_Y As Integer, ByRef YUV_U As Integer, ByRef YUV_V As Integer)
    
    YUV_Y = (0.098 * RGB_R) + (0.504 * RGB_G) + (0.257 * RGB_B) + 16
    YUV_U = -(0.071 * RGB_R) - (0.368 * RGB_G) + (0.439 * RGB_B) + 128
    YUV_V = (0.439 * RGB_R) - (0.291 * RGB_G) - (0.148 * RGB_B) + 128
    
    YUV_Y = setRange(YUV_Y, 0, 255)
    YUV_U = setRange(YUV_U, 0, 255)
    YUV_V = setRange(YUV_V, 0, 255)
    
End Sub

Public Sub YUVtoRGB(ByVal YUV_Y As Integer, ByVal YUV_U As Integer, ByVal YUV_V As Integer, _
                    ByRef RGB_R As Integer, ByRef RGB_G As Integer, ByRef RGB_B As Integer)

    RGB_R = 1.164 * (YUV_Y - 16) + 2.018 * (YUV_V - 128)
    RGB_G = 1.164 * (YUV_Y - 16) - 0.813 * (YUV_U - 128) - 0.391 * (YUV_V - 128)
    RGB_B = 1.164 * (YUV_Y - 16) + 1.596 * (YUV_U - 128)
    
    RGB_R = setRange(RGB_R, 0, 255)
    RGB_G = setRange(RGB_G, 0, 255)
    RGB_B = setRange(RGB_B, 0, 255)

End Sub

'Rechnet erst RGB in XYUV danach in LAB
Public Sub RGBtoLAB(ByVal RGB_R As Integer, ByVal RGB_G As Integer, ByVal RGB_B As Integer, _
                    ByRef LAB_L As Integer, ByRef LAB_A As Integer, ByRef LAB_B As Integer)
                    
    Dim X As Double
    Dim Y As Double
    Dim Z As Double
    Dim fX As Double
    Dim fY As Double
    Dim fZ As Double
    
    
    X = 0.412453 * RGB_R + 0.35758 * RGB_G + 0.180423 * RGB_B
    Y = 0.212671 * RGB_R + 0.71516 * RGB_G + 0.072169 * RGB_B
    Z = 0.019334 * RGB_R + 0.119193 * RGB_G + 0.950227 * RGB_B
       
    X = X / (255 * 0.950456)
    Y = Y / 255
    Z = Z / (255 * 1.088754)

    If Y > 0.008856 Then
        fY = Y ^ (1 / 3)
        LAB_L = Int(116 * fY - 16 + 0.5)
    Else
        fY = 7.787 * Y + 16 / 116
        LAB_L = Int(903.3 * Y + 0.5)
    End If

    If X > 0.008856 Then
        fX = X ^ (1 / 3)
    Else
        fX = 7.787 * X + 16 / 116
    End If

    If Z > 0.008856 Then
        fZ = Z ^ (1 / 3)
    Else
        fZ = 7.787 * Z + 16 / 116
    End If

    LAB_A = Int(500 * (fX - fY) + 0.5)
    LAB_B = Int(200 * (fY - fZ) + 0.5)
    
End Sub
Public Function LABtoRGB(ByVal LAB_L As Integer, ByVal LAB_A As Integer, ByVal LAB_B As Integer, _
                    ByRef RGB_R As Integer, ByRef RGB_G As Integer, ByRef RGB_B As Integer)
                    
    Dim X As Double
    Dim Y As Double
    Dim Z As Double
    Dim fX As Double
    Dim fY As Double
    Dim fZ As Double
    Dim RR As Integer
    Dim GG As Integer
    Dim BB As Integer
    
    X = LAB_L
    Y = LAB_A
    Z = LAB_B
    
    fY = ((LAB_L + 16) / 116) ^ 3
    If fY < 0.008856 Then fY = LAB_L / 903.3
    Y = fY

    If (fY > 0.008856) Then
        fY = fY ^ (1 / 3)
    Else
        fY = 7.787 * fY + 16 / 116
    End If

    fX = LAB_A / 500 + fY
    If fX > 0.206893 Then
        X = fX ^ 3
    Else
        X = (fX - 16 / 116) / 7.787
    End If

    fZ = fY - LAB_B / 200
    If fZ > 0.206893 Then
        Z = fZ ^ 3
    Else
        Z = (fZ - 16 / 116) / 7.787
    End If

    X = X * (0.950456 * 255)
    Y = Y * 255
    Z = Z * (1.088754 * 255)
    
    RR = Int(3.240479 * X - 1.53715 * Y - 0.498535 * Z + 0.5)
    GG = Int(-0.969256 * X + 1.875992 * Y + 0.041556 * Z + 0.5)
    BB = Int(0.055648 * X - 0.204043 * Y + 1.057311 * Z + 0.5)
    
    RGB_R = setRange(RR, 0, LAB_RGBMAX)
    RGB_G = setRange(GG, 0, LAB_RGBMAX)
    RGB_B = setRange(BB, 0, LAB_RGBMAX)
    
End Function

