VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsColorModels"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False

' VISUAL BASIC WORLD
' ===========================================
' Das groe Portal zum Thema Visual Basic.
'
' Wenn Ihnen dieser Source Code gefallen hat,
' dann empfehlen Sie Visual Basic World bitte
' weiter und/oder setzen Sie einen Link auf:
'
' http://www.visualbasicworld.de/
'
' Vernetzen Sie sich mit uns:
'
' http://twitter.com/visualbasicwrld
'
' Autor: Benjamin Wilger

Option Explicit
'Dies ist das Herz des Proggies. Die Klasse koordiniert alle Farbmodelle und
'rechnet zwischen ihnen um.
'Handhabung:
'Zuerst muss das aktuelle Farbmodell eingestellt werden, dies geschieht mit
'setColorModel. Standardmig wird RGB ausgewhlt.
'Mittels getColorModel bekommt Ihr dementsprechend das aktuelle Farb-
'modell.
'Dann knnt Ihr mit setXXX (XXX steht fr das Krzel eines Farbmodells z.B. RGB)
'die Farbe einstellen und mit getXXX die Werte erhalten.
'Eigentlich recht simpel.

Dim m_RGB_R As Integer, m_RGB_G As Integer, m_RGB_B As Integer
Dim m_HSB_H As Integer, m_HSB_S As Integer, m_HSB_B As Integer
Dim m_HSV_H As Integer, m_HSV_S As Integer, m_HSV_V As Integer
Dim m_LAB_L As Integer, m_LAB_A As Integer, m_LAB_B As Integer
Dim m_YUV_Y As Integer, m_YUV_U As Integer, m_YUV_V As Integer
Dim m_CMY_C As Integer, m_CMY_M As Integer, m_CMY_Y As Integer
Dim m_CMYK_C As Integer, m_CMYK_M As Integer, m_CMYK_Y As Integer, m_CMYK_K As Integer

Public Enum Models
    mRGB = 0
    mHSB = 1
    mHSV = 2
    mLAB = 3
    mYUV = 4
    mCMY = 5
    mCMYK = 6
End Enum

Private CurrModel As Models
Private Sub calcRGB()

    Select Case CurrModel
        Case mRGB
            Exit Sub
        Case mHSB
            HSBtoRGB m_HSB_H, m_HSB_S, m_HSB_B, m_RGB_R, m_RGB_G, m_RGB_B
        Case mHSV
            HSVtoRGB m_HSV_H, m_HSV_S, m_HSV_V, m_RGB_R, m_RGB_G, m_RGB_B
        Case mLAB
            LABtoRGB m_LAB_L, m_LAB_A, m_LAB_B, m_RGB_R, m_RGB_G, m_RGB_B
        Case mYUV
            YUVtoRGB m_YUV_Y, m_YUV_U, m_YUV_V, m_RGB_R, m_RGB_G, m_RGB_B
        Case mCMY
            CMYtoRGB m_CMY_C, m_CMY_M, m_CMY_Y, m_RGB_R, m_RGB_G, m_RGB_B
        Case mCMYK
            CMYKtoRGB m_CMYK_C, m_CMYK_M, m_CMYK_Y, m_CMYK_K, m_RGB_R, m_RGB_G, m_RGB_B
    End Select
    
End Sub
Private Sub calcHSB()

    Dim R As Integer, G As Integer, B As Integer
    
    Select Case CurrModel
        Case mRGB
            RGBtoHSB m_RGB_R, m_RGB_G, m_RGB_B, m_HSB_H, m_HSB_S, m_HSB_B
        Case mHSB
            Exit Sub
        Case mHSV
            HSVtoRGB m_HSV_H, m_HSV_S, m_HSV_V, R, G, B
            RGBtoHSB m_RGB_R, m_RGB_G, m_RGB_B, m_HSB_H, m_HSB_S, m_HSB_B
        Case mLAB
            LABtoRGB m_LAB_L, m_LAB_A, m_LAB_B, R, G, B
            RGBtoHSB R, G, B, m_HSB_H, m_HSB_S, m_HSB_B
        Case mYUV
            YUVtoRGB m_YUV_Y, m_YUV_U, m_YUV_V, R, G, B
            RGBtoHSB R, G, B, m_HSB_H, m_HSB_S, m_HSB_B
        Case mCMY
            CMYtoRGB m_CMY_C, m_CMY_M, m_CMY_Y, R, G, B
            RGBtoHSB R, G, B, m_HSB_H, m_HSB_S, m_HSB_B
        Case mCMYK
            CMYKtoRGB m_CMYK_C, m_CMYK_M, m_CMYK_Y, m_CMYK_K, R, G, B
            RGBtoHSB R, G, B, m_HSB_H, m_HSB_S, m_HSB_B

    End Select
    
End Sub
Private Sub calcHSV()

    Dim R As Integer, G As Integer, B As Integer

    Select Case CurrModel
        Case mRGB
            RGBtoHSV m_RGB_R, m_RGB_G, m_RGB_B, m_HSV_H, m_HSV_S, m_HSV_V
        Case mHSB
            HSBtoRGB m_HSB_H, m_HSB_S, m_HSB_B, R, G, B
            RGBtoHSV R, G, B, m_HSV_H, m_HSV_S, m_HSV_V
        Case mHSV
            Exit Sub
        Case mLAB
            LABtoRGB m_LAB_L, m_LAB_A, m_LAB_B, R, G, B
            RGBtoHSV R, G, B, m_HSV_H, m_HSV_S, m_HSV_V
        Case mYUV
            YUVtoRGB m_YUV_Y, m_YUV_U, m_YUV_V, R, G, B
            RGBtoHSV R, G, B, m_HSV_H, m_HSV_S, m_HSV_V
        Case mCMY
            CMYtoRGB m_CMY_C, m_CMY_M, m_CMY_Y, R, G, B
            RGBtoHSV R, G, B, m_HSV_H, m_HSV_S, m_HSV_V
        Case mCMYK
            CMYKtoRGB m_CMYK_C, m_CMYK_M, m_CMYK_Y, m_CMYK_K, R, G, B
            RGBtoHSV R, G, B, m_HSV_H, m_HSV_S, m_HSV_V
    End Select
    
End Sub
Private Sub calcLAB()

    Dim R As Integer, G As Integer, B As Integer

    Select Case CurrModel
        Case mRGB
            RGBtoLAB m_RGB_R, m_RGB_G, m_RGB_B, m_LAB_L, m_LAB_A, m_LAB_B
        Case mHSB
            HSBtoRGB m_HSB_H, m_HSB_S, m_HSB_B, R, G, B
            RGBtoLAB R, G, B, m_LAB_L, m_LAB_A, m_LAB_B
        Case mHSV
            HSVtoRGB m_HSV_H, m_HSV_S, m_HSV_V, R, G, B
            RGBtoLAB R, G, B, m_LAB_L, m_LAB_A, m_LAB_B
        Case mLAB
            Exit Sub
        Case mYUV
            YUVtoRGB m_YUV_Y, m_YUV_U, m_YUV_V, R, G, B
            RGBtoLAB R, G, B, m_LAB_L, m_LAB_A, m_LAB_B
        Case mCMY
            CMYtoRGB m_CMY_C, m_CMY_M, m_CMY_Y, R, G, B
            RGBtoLAB R, G, B, m_LAB_L, m_LAB_A, m_LAB_B
        Case mCMYK
            CMYKtoRGB m_CMYK_C, m_CMYK_M, m_CMYK_Y, m_CMYK_K, R, G, B
            RGBtoLAB R, G, B, m_LAB_L, m_LAB_A, m_LAB_B
    End Select
    
End Sub
Private Sub calcYUV()

    Dim R As Integer, G As Integer, B As Integer

    Select Case CurrModel
        Case mRGB
            RGBtoYUV m_RGB_R, m_RGB_G, m_RGB_B, m_YUV_Y, m_YUV_U, m_YUV_V
        Case mHSB
            HSBtoRGB m_HSB_H, m_HSB_S, m_HSB_B, R, G, B
            RGBtoYUV R, G, B, m_YUV_Y, m_YUV_U, m_YUV_V
        Case mHSV
            HSVtoRGB m_HSV_H, m_HSV_S, m_HSV_V, R, G, B
            RGBtoYUV R, G, B, m_YUV_Y, m_YUV_U, m_YUV_V
        Case mLAB
            LABtoRGB m_LAB_L, m_LAB_A, m_LAB_B, R, G, B
            RGBtoYUV R, G, B, m_YUV_Y, m_YUV_U, m_YUV_V
        Case mYUV
            Exit Sub
        Case mCMY
            CMYtoRGB m_CMY_C, m_CMY_M, m_CMY_Y, R, G, B
            RGBtoYUV R, G, B, m_YUV_Y, m_YUV_U, m_YUV_V
        Case mCMYK
            CMYKtoRGB m_CMYK_C, m_CMYK_M, m_CMYK_Y, m_CMYK_K, R, G, B
            RGBtoYUV R, G, B, m_YUV_Y, m_YUV_U, m_YUV_V
    End Select
    
End Sub
Private Sub calcCMY()

    Dim R As Integer, G As Integer, B As Integer

    Select Case CurrModel
        Case mRGB
            RGBtoCMY m_RGB_R, m_RGB_G, m_RGB_B, m_CMY_C, m_CMY_M, m_CMY_Y
        Case mHSB
            HSBtoRGB m_HSB_H, m_HSB_S, m_HSB_B, R, G, B
            RGBtoCMY R, G, B, m_CMY_C, m_CMY_M, m_CMY_Y
        Case mHSV
            HSVtoRGB m_HSV_H, m_HSV_S, m_HSV_V, R, G, B
            RGBtoCMY R, G, B, m_CMY_C, m_CMY_M, m_CMY_Y
        Case mLAB
            LABtoRGB m_LAB_L, m_LAB_A, m_LAB_B, R, G, B
            RGBtoCMY R, G, B, m_CMY_C, m_CMY_M, m_CMY_Y
        Case mYUV
            YUVtoRGB m_YUV_Y, m_YUV_U, m_YUV_V, R, G, B
            RGBtoCMY R, G, B, m_CMY_C, m_CMY_M, m_CMY_Y
        Case mCMY
            Exit Sub
        Case mCMYK
            CMYKtoRGB m_CMYK_C, m_CMYK_M, m_CMYK_Y, m_CMYK_K, R, G, B
            RGBtoCMY R, G, B, m_CMY_C, m_CMY_M, m_CMY_Y
    End Select
    
End Sub
Private Sub calcCMYK()

    Dim R As Integer, G As Integer, B As Integer

    Select Case CurrModel
        Case mRGB
            RGBtoCMYK m_RGB_R, m_RGB_G, m_RGB_B, m_CMYK_C, m_CMYK_M, m_CMYK_Y, m_CMYK_K
        Case mHSB
            HSBtoRGB m_HSB_H, m_HSB_S, m_HSB_B, R, G, B
            RGBtoCMYK R, G, B, m_CMYK_C, m_CMYK_M, m_CMYK_Y, m_CMYK_K
        Case mHSV
            HSVtoRGB m_HSV_H, m_HSV_S, m_HSV_V, R, G, B
            RGBtoCMYK R, G, B, m_CMYK_C, m_CMYK_M, m_CMYK_Y, m_CMYK_K
        Case mLAB
            LABtoRGB m_LAB_L, m_LAB_A, m_LAB_B, R, G, B
            RGBtoCMYK R, G, B, m_CMYK_C, m_CMYK_M, m_CMYK_Y, m_CMYK_K
        Case mYUV
            YUVtoRGB m_YUV_Y, m_YUV_U, m_YUV_V, R, G, B
            RGBtoCMYK R, G, B, m_CMYK_C, m_CMYK_M, m_CMYK_Y, m_CMYK_K
        Case mCMY
            CMYtoRGB m_CMY_C, m_CMY_M, m_CMY_Y, R, G, B
            RGBtoCMYK R, G, B, m_CMYK_C, m_CMYK_M, m_CMYK_Y, m_CMYK_K
        Case mCMYK
            Exit Sub
    End Select
    
End Sub
Private Sub Class_Initialize()

    CurrModel = mRGB
    
End Sub
Public Sub getCMY(ByRef CMY_C As Integer, ByRef CMY_M As Integer, ByRef CMY_Y As Integer)
    If Not CurrModel = mCMY Then calcCMY
    
    CMY_C = m_CMY_C
    CMY_M = m_CMY_M
    CMY_Y = m_CMY_Y
    
End Sub
Public Sub getCMYK(ByRef CMYK_C As Integer, ByRef CMYK_M As Integer, ByRef CMYK_Y As Integer, ByRef CMYK_K As Integer)
    If Not CurrModel = mCMYK Then calcCMYK
    
    CMYK_C = m_CMYK_C
    CMYK_M = m_CMYK_M
    CMYK_Y = m_CMYK_Y
    CMYK_K = m_CMYK_K
    
End Sub
Public Sub getHSB(ByRef HSB_H As Integer, ByRef HSB_S As Integer, ByRef HSB_B As Integer)
    If Not CurrModel = mHSB Then calcHSB
    
    HSB_H = m_HSB_H
    HSB_S = m_HSB_S
    HSB_B = m_HSB_B
    
End Sub
Public Sub getHSV(ByRef HSV_H As Integer, ByRef HSV_S As Integer, ByRef HSV_B As Integer)
    If Not CurrModel = mHSV Then calcHSV
    
    HSV_H = m_HSV_H
    HSV_S = m_HSV_S
    HSV_B = m_HSV_V
    
End Sub
Public Sub getLAB(ByRef LAB_L As Integer, ByRef LAB_A As Integer, ByRef LAB_B As Integer)
    If Not CurrModel = mLAB Then calcLAB
    
    LAB_L = m_LAB_L
    LAB_A = m_LAB_A
    LAB_B = m_LAB_B
    
End Sub
Public Sub getYUV(ByRef YUV_Y As Integer, ByRef YUV_U As Integer, ByRef YUV_V As Integer)
    If Not CurrModel = mYUV Then calcYUV
    
    YUV_Y = m_YUV_Y
    YUV_U = m_YUV_U
    YUV_V = m_YUV_V
    
End Sub
Public Sub getRGB(ByRef RGB_R As Integer, ByRef RGB_G As Integer, ByRef RGB_B As Integer)
    If Not CurrModel = mRGB Then calcRGB
    
    RGB_R = m_RGB_R
    RGB_G = m_RGB_G
    RGB_B = m_RGB_B
    
End Sub
Public Sub setCMY(ByVal CMY_C As Integer, ByVal CMY_M As Integer, ByVal CMY_Y As Integer)
    
    m_CMY_C = CMY_C
    m_CMY_M = CMY_M
    m_CMY_Y = CMY_Y
    
    CurrModel = mCMY
    
End Sub
Public Sub setCMYK(ByVal CMYK_C As Integer, ByVal CMYK_M As Integer, ByVal CMYK_Y As Integer, ByVal CMYK_K As Integer)
    
    m_CMYK_C = CMYK_C
    m_CMYK_M = CMYK_M
    m_CMYK_Y = CMYK_Y
    m_CMYK_K = CMYK_K
    
    CurrModel = mCMYK
    
End Sub
Public Sub setColorModel(m As Models)

    CurrModel = m
    
End Sub
Public Function getColorModel() As Models

    getColorModel = CurrModel
    
End Function
Public Sub setHSB(ByVal HSB_H As Integer, ByVal HSB_S As Integer, ByVal HSB_B As Integer)

    m_HSB_H = HSB_H
    m_HSB_S = HSB_S
    m_HSB_B = HSB_B
    
    CurrModel = mHSB
    
End Sub
Public Sub setHSV(ByVal HSV_H As Integer, ByVal HSV_S As Integer, ByVal HSV_V As Integer)

    m_HSV_H = HSV_H
    m_HSV_S = HSV_S
    m_HSV_V = HSV_V
    
    CurrModel = mHSV
    
End Sub
Public Sub setLAB(ByVal LAB_L As Integer, ByVal LAB_A As Integer, ByVal LAB_B As Integer)

    m_LAB_L = LAB_L
    m_LAB_A = LAB_A
    m_LAB_B = LAB_B
    
    CurrModel = mLAB
    
End Sub
Public Sub setYUV(ByVal YUV_Y As Integer, ByVal YUV_U As Integer, ByVal YUV_V As Integer)

    m_YUV_Y = YUV_Y
    m_YUV_U = YUV_U
    m_YUV_V = YUV_V
    
    CurrModel = mYUV
    
End Sub
Public Sub setRGB(ByVal RGB_R As Integer, ByVal RGB_G As Integer, ByVal RGB_B As Integer)

    m_RGB_R = RGB_R
    m_RGB_G = RGB_G
    m_RGB_B = RGB_B
    
    CurrModel = mRGB
    
End Sub

